using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FollowPlayerCamera2D : MonoBehaviour
{
    public Transform player; // reference to the player object
    public float smoothTime = 0.3f; // smoothing time for camera movement
    private Vector3 velocity = Vector3.zero; // velocity for smoothing

    private void FixedUpdate()
    {
        Vector3 targetPos = player.position; // target position to follow the player
        targetPos.z = transform.position.z; // keep camera's z position constant
        targetPos.y = transform.position.y; //keep Y, we don't want to move up and down actually
        transform.position = Vector3.SmoothDamp(transform.position, targetPos, ref velocity, smoothTime); // smooth camera movement
    }
}
