/*

Source code by Seth A. Robinson

 */

//#define RT_NOAUDIO

using UnityEngine;
using System.Collections;
using System;
using System.IO;
using System.Text;
using UnityEngine.UI;
using System.Collections.Generic;
using DG.Tweening;
//using UnityEngine.Networking;

public class GameLogic : MonoBehaviour
{
     static GameLogic _this = null;
    public static string GetName()
    {
        return Get().name;
    }

    private void Awake()
    {

        Application.targetFrameRate = 20000;
        QualitySettings.vSyncCount = 0;
        //QualitySettings.antiAliasing = 4;
        /*
        Debug.unityLogger.filterLogType = LogType.Log;

        Application.SetStackTraceLogType(LogType.Log, StackTraceLogType.ScriptOnly);
        Application.SetStackTraceLogType(LogType.Error, StackTraceLogType.ScriptOnly);
        Application.SetStackTraceLogType(LogType.Assert, StackTraceLogType.ScriptOnly);
        Application.SetStackTraceLogType(LogType.Exception, StackTraceLogType.ScriptOnly);
        Application.SetStackTraceLogType(LogType.Warning, StackTraceLogType.ScriptOnly);
        */
    }

    // Use this for initialization
    void Start()
    {
        DOTween.Init(true, true, LogBehaviour.Verbose).SetCapacity(200, 20);
        // RTAudioManager.Get().SetDefaultMusicVol(0.4f);
        _this = this;

#if RT_NOAUDIO
		AudioListener.pause = true;
#endif

/*
      if (RTUtil.DoesCommandLineWordExist("-runfullserver"))
        {
            print("Detected -runfullserver flag");
            _isServer = true;
        }

    */

     RTConsole.Get().SetShowUnityDebugLogInConsole(true);
       
        //RTEventManager.Get().Schedule(RTAudioManager.GetName(), "PlayMusic", 1, "intro");
        string version = "Unity V "+ Application.unityVersion+" :";

#if NET_2_0
        version += " Net 2.0 API";
#endif
#if NET_2_0_SUBSET
        version += " Net 2.0 Subset API";
#endif

#if NET_4_6
            version += " .Net 4.6 API";
#endif

        #if RT_BETA
        print ("Beta build detected!");
#endif

       
        RTConsole.Get().SetMirrorToDebugLog(true);
 
    }

    static public GameLogic Get()
	{
		return _this;
	}
 
	void OnApplicationQuit() 
	{
        // Make sure prefs are saved before quitting.
        //PlayerPrefs.Save();
        RTConsole.Log("Application quitting normally");

//        NetworkTransport.Shutdown();
        print("QUITTING!");
    }
    

    private void OnDestroy()
    {
        print("Game logic destroyed");
    }
    
    // Update is called once per frame
    void Update () 
    {

    }

}
