using DG.Tweening;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Gem : MonoBehaviour
{
    // Start is called before the first frame update
   float hoverHeight = 0.5f;
   float hoverDuration = 1f;
    private Tweener _tween;
    bool _bDying = false;
    SpriteRenderer _spriteRenderer;
    private void Awake()
    {
        _spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
    }

    private void Start()
    {
        // Start the hover tween
        _tween = transform.DOMoveY(transform.position.y + hoverHeight, hoverDuration)
            .SetEase(Ease.InOutSine)
            .SetLoops(-1, LoopType.Yoyo);
    }


    public void OnCollectGem()
    {
        if (_bDying) return;

        if (_tween != null)
        {
            _tween.Kill();
        }

        //Debug.Log("Collected gem");
        RTAudioManager.Get().PlayEx("gem2", 1, Random.Range(0.5f, 2));
            _spriteRenderer.DOFade(0, 1)
                    .OnComplete(() => Destroy(gameObject));
            _spriteRenderer.transform.DOScale(Vector3.zero, 1);
            _bDying = true;
        
        Player.Get().ModGemsAndUpdateText(1);

        Gopher.Get().OnGotGem();
    }
  
   /* private void OnCollisionEnter2D(Collision2D collision)
    {
        if (collision.gameObject.CompareTag("Player"))
        {
            Debug.Log("Touched player");
        }
    }*/
    // Update is called once per frame
    void Update()
    {
        
    }

    private void OnDestroy()
    {
        // Kill the tween when the gameobject is destroyed
        if (_tween != null)
        {
            _tween.Kill();
        }
    }

}
