using DG.Tweening;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Gopher : MonoBehaviour
{
    // Start is called before the first frame update
    float _initialDistanceTargetFromPlayerX = 10;
    private Tweener _tween;
    float shakeDuration = 0.1f;
    float shakeStrength = 0.4f;
    public GameObject _visualObj;
    static Gopher _this;
    float _speed = 0.1f;
    float _accel = 3;
    float _startingSpeed = 0;
    bool _bIsCloseToPlayer = false;
    public SpriteRenderer _spriteRenderer;
    float _maxSpeed = 18;
    int _curSprite = 0;

    public List<Sprite> _sprites;

    float _animTimer = 0;

    public static Gopher Get() { return _this; }

    private void Awake()
    {
        _this = this;
    }
    void Start()
    {
        ResetGame();
    }

    public void ResetGame()
    {
        _speed = _startingSpeed;

        //move right behing the player, wherever he is
        var vPos = transform.position;
        float targetX = Player.Get().transform.position.x - _initialDistanceTargetFromPlayerX;
        vPos.x = targetX;
        transform.position = vPos;

        var originalLocalPosition = _visualObj.transform.localPosition;
        if (_tween != null)
        {
            _tween.Kill();
        }

        // Start the shake tween
        _tween = _visualObj.transform.DOLocalMove(originalLocalPosition + new Vector3(Random.Range(-shakeStrength, shakeStrength), Random.Range(-shakeStrength, shakeStrength), 0), shakeDuration)
                .SetLoops(-1, LoopType.Yoyo)
                .SetEase(Ease.InOutSine);
    }

    void UpdatePosition()
    {
        var vPos = transform.position;
        vPos.x = vPos.x + _speed * Time.deltaTime;
        transform.position = vPos;
    }

    public void OnGotGem()
    {
        if (_bIsCloseToPlayer)
        {
            _speed -= (_accel*6) * Time.deltaTime;
        }
    }
    // Update is called once per frame
    void Update()
    {
        if (_animTimer < Time.time)
        {
            //next frame
            _spriteRenderer.sprite = _sprites[Random.Range(0, _sprites.Count)];
            _animTimer = Time.time + 0.1f;
        }
        /*
        float closeToPlayer = Player.Get().transform.position.x - _initialDistanceTargetFromPlayerX;

        if (transform.position.x < closeToPlayer)
        {
            _speed += _accel * Time.deltaTime;
            _bIsCloseToPlayer = false;
        } else
        {
            _bIsCloseToPlayer = true;
            _speed += (_accel/5) * Time.deltaTime;
        }
       

        if (_speed > _maxSpeed) _speed = _maxSpeed;

        */
        UpdatePosition();
    }
}
